/************************************************************
v1-  1 dagger working well, moves about right
trying to get the firing animation done right
v2 - 1 dagger firing well and animation sinc'ed
v3 - added basic enemy. Need to apply it to both directions. 
and added hit code. need to apply die. increased 
resolution to 1280 by 960. seems betters.
v4 - enemy matrix added, enemy dies.
v5 - enemy awareness. multiple landscapes.
V6: remove extra directions for skelaton
V7: fire dagger in multiple directions, dag disappers at end of screen

todo: multiple enemies

************************************************************/
// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

#define INITGUID // if not done elsewhere

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream> // include important C/C++ stuff
#include <fstream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>


#include <ddraw.h>     // directX includes
#include <dinput.h>
#include "T3DLIB1.H"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    1280  // size of screen
#define SCREEN_HEIGHT   960
#define SCREEN_BPP      8    // bits per pixel

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

// skelaton directions
#define SKELATON_EAST         0
#define SKELATON_WEST         1
#define SKELATON_FIRE_R	      2
#define SKELATON_FIRE_L	      3

#define PIRATE_RIGHT	0
#define PIRATE_LEFT		1
#define PIRATE_R_ATT	2
#define PIRATE_L_ATT	3
#define NUMB_PIRATES	7

#define DAGGER_RIGHT	0
#define DAGGER_LEFT		1


#define WALL_ANIMATION_COLOR  29
#define FLOOR_COLOR       115
#define Max_Dag 1
#define RIGHT 1
#define LEFT -1


// TYPES ///////////////////////////////////////////////////


// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);

// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[80];                // used to print text

// directinput globals
LPDIRECTINPUT8        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE8  lpdikey   = NULL;    // dinput keyboard
LPDIRECTINPUTDEVICE8  lpdimouse = NULL;    // dinput mouse
LPDIRECTINPUTDEVICE8  lpdijoy   = NULL;    // dinput joystick 
GUID                 joystickGUID;        // guid for main joystick
char                 joyname[80];         // name of joystick

// these contain the target records for all di input packets
UCHAR        keyboard_state[256]; // contains keyboard state table
DIMOUSESTATE mouse_state;         // contains state of mouse
DIJOYSTATE   joy_state;           // contains state of joystick

// demo globals
BOB          skelaton;     // the player skelaton
BOB          dagger;     // the player skelaton
BOB	pirate[NUMB_PIRATES];


struct Info
{
	int health;
	int screen;
	int x;
	int y;
	int speed;
	bool aware;
	int direction;
	int thrown;
	int alive;
};

int pir_dir=1;
bool dag_count=0;
int dag_dir;
int fire_anim=0;
int count=0;
Info enemy_info[NUMB_PIRATES];
Info player_info;
int curr_page=0;


int dagger_anims[2][4] = {
	{0,0,0,0},
	{1+4,1+4,1+4,1+4},
};
int pirate_anims[4][4] = { 
	{2,0,3,1},
	{2+4,0+4,3+4,1+4},
	{1+8,0+8,2+8,3+8},
	{1+12,0+12,2+12,3+12},
};




// animation sequences for bob
int skelaton_anims[9][4] = { 
	{0,1,0,2},
	{0+4,1+4,0+4,2+4},
	{0+8,3+8,0+8,0+8,},
	{0+12,3+12,0+12,0+12,},
};
char rand_things[5][80]={
	"test",
	"fire",
	"dog",
	"arrrr....",
	"Lets kill all the pirates",
};

BOB          plasma;       // players weapon

//BITMAP_IMAGE reactor;      // the background   
BITMAP_IMAGE landscape[4];      // the background    landscape 3 pages 3x1


// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
							UINT msg, 
							WPARAM wparam, 
							LPARAM lparam)
{
	// this is the main message handler of the system
	PAINTSTRUCT		ps;		// used in WM_PAINT
	HDC				hdc;	// handle to a device context
	char buffer[80];        // used to print strings

	// what is the message 
	switch(msg)
	{	
	case WM_CREATE: 
		{
			// do initialization stuff here
			// return success
			return(0);
		} break;

	case WM_PAINT: 
		{
			// simply validate the window 
			hdc = BeginPaint(hwnd,&ps);	 

			// end painting
			EndPaint(hwnd,&ps);

			// return success
			return(0);
		} break;

	case WM_DESTROY: 
		{

			// kill the application, this sends a WM_QUIT message 
			PostQuitMessage(0);

			// return success
			return(0);
		} break;

	default:break;

	} // end switch

	// process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
				   HINSTANCE hprevinstance,
				   LPSTR lpcmdline,
				   int ncmdshow)
{

	WNDCLASSEX winclass; // this will hold the class we create
	HWND	   hwnd;	 // generic window handle
	MSG		   msg;		 // generic message
	HDC        hdc;      // graphics device context

	// first fill in the window class stucture
	winclass.cbSize         = sizeof(WNDCLASSEX);
	winclass.style			= CS_DBLCLKS | CS_OWNDC | 
		CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= hinstance;
	winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
	winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName	= NULL;
	winclass.lpszClassName	= WINDOW_CLASS_NAME;
	winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

	// save hinstance in global
	main_instance = hinstance;

	// register the window class
	if (!RegisterClassEx(&winclass))
		return(0);

	// create the window
	if (!(hwnd = CreateWindowEx(NULL,                  // extended style
		WINDOW_CLASS_NAME,     // class
		"Kirit", // title
		WS_POPUP | WS_VISIBLE,
		0,0,	  // initial x,y
		SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
		NULL,	  // handle to parent 
		NULL,	  // handle to menu
		hinstance,// instance of this application
		NULL)))	// extra creation parms
		return(0);

	// save main window handle
	main_window_handle = hwnd;

	// initialize game here
	Game_Init();

	// enter main event loop
	while(TRUE)
	{
		// test if there is a message in queue, if so get it
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
			// test if this is a quit
			if (msg.message == WM_QUIT)
				break;

			// translate any accelerator keys
			TranslateMessage(&msg);

			// send the message to the window proc
			DispatchMessage(&msg);
		} // end if

		// main game processing goes here
		Game_Main();

	} // end while

	// closedown game here
	Game_Shutdown();

	// return to Windows like this
	return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
	// this function is where you do all the initialization 
	// for your game

	int index;         // looping var
	char temp[100];
	int t;
	
	char filename[80]; // used to build up files names
	std::ifstream in;
	in.open("script.txt");
in>>t;
for (int i=0;i<t;i++)
{
	in>>enemy_info[i].screen;
	in>>enemy_info[i].x;
	in>>enemy_info[i].y;
	in>>enemy_info[i].health;
	in>>enemy_info[i].direction;
			
	enemy_info[i].aware=0;
	enemy_info[i].alive=1;
}

	in.close();
	// initialize directdraw
	DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);


#if 0 // directinput7 method

	// first create the direct input object
	if (DirectInputCreateEx(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput7, (void **)&lpdi,NULL)!=DI_OK)
		return(0);

	// create a keyboard device  //////////////////////////////////
	if (lpdi->CreateDeviceEx(GUID_SysKeyboard, IID_IDirectInputDevice7, (void **)&lpdikey, NULL)!=DI_OK)
		return(0);

#endif


	// first create the direct input object
	if (DirectInput8Create(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput8, (void **)&lpdi,NULL)!=DI_OK)
		return(0);

	// create a keyboard device  //////////////////////////////////
	if (lpdi->CreateDevice(GUID_SysKeyboard, &lpdikey, NULL)!=DI_OK)
		return(0);


	// set cooperation level
	if (lpdikey->SetCooperativeLevel(main_window_handle, 
		DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)!=DI_OK)
		return(0);

	// set data format
	if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
		return(0);

	// acquire the keyboard
	if (lpdikey->Acquire()!=DI_OK)
		return(0);

	///////////////////////////////////////////////////////////
	// load the background
	//Load_Bitmap_File(&bitmap8bit, "REACTOR.BMP");




	for (index = 0; index<4; index++)
	{
		// build up file name
		sprintf(filename,"LANDSCAPE%d.BMP",index+1);

		// load the background
		Load_Bitmap_File(&bitmap8bit, filename);

		// create and load the reactor bitmap image
		Create_Bitmap(&landscape[index], 0,0, 640, 480);
		Load_Image_Bitmap(&landscape[index],&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap8bit);

	} // end for index


	// set the palette to background image palette
	Set_Palette(bitmap8bit.palette);


	// now let's load in all the frames for the dagger!!!

	// create dagger bob
	if (!Create_BOB(&dagger,0,0,18,8,8,
		BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
		return(0);
	for (int direction = 0; direction < 2; direction++)
	{ 
	Load_Bitmap_File(&bitmap8bit,"dagger.bmp");
		Load_Frame_BOB(&dagger,&bitmap8bit,0+direction*4,direction,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&dagger,&bitmap8bit,1+direction*4,direction,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&dagger,&bitmap8bit,2+direction*4,direction,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&dagger,&bitmap8bit,3+direction*4,direction,0,BITMAP_EXTRACT_MODE_CELL);  

		// unload the bitmap file
		Unload_Bitmap_File(&bitmap8bit);

		// set the animation sequences for skelaton
		Load_Animation_BOB(&dagger,direction,4,dagger_anims[direction]);

	} // end for direction

	Set_Animation_BOB(&dagger, 0);
	Set_Anim_Speed_BOB(&dagger, 4);
	Set_Vel_BOB(&dagger, 0,0);
	Set_Pos_BOB(&dagger, 0, 0);


	// now let's load in all the frames for the skelaton!!!

	// create skelaton bob
	if (!Create_BOB(&skelaton,0,0,56,72,16,
		BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
		return(0);

	// load the frames in 8 directions, 4 frames each
	// each set of frames has a walk and a fire, frame sets
	// are loaded in counter clockwise order looking down
	// from a birds eys view or the x-z plane
	for (int direction = 0; direction < 4; direction++)
	{ 
		// build up file name
		sprintf_s(filename,"SKELSP%d.BMP",direction);

		// load in new bitmap file
		Load_Bitmap_File(&bitmap8bit,filename);

		Load_Frame_BOB(&skelaton,&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&skelaton,&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&skelaton,&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&skelaton,&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  

		// unload the bitmap file
		Unload_Bitmap_File(&bitmap8bit);

		// set the animation sequences for skelaton
		Load_Animation_BOB(&skelaton,direction,4,skelaton_anims[direction]);

	} // end for direction

	player_info.direction=RIGHT;
	player_info.screen=1;
	player_info.health=100;
	player_info.speed=5;
	player_info.x=0;
	player_info.y=128;

	// set up stating state of skelaton
	Set_Animation_BOB(&skelaton, 0);
	Set_Anim_Speed_BOB(&skelaton, 4);
	Set_Vel_BOB(&skelaton, 0,0);
	Set_Pos_BOB(&skelaton, 0, 400);

	// now let's load in all the frames for the pirate!!!

	// create pirate bob
	for (int i=0;i<NUMB_PIRATES;i++)
	{
		if (!Create_BOB(&pirate[i],0,0,72,75,36,
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
			return(0);

		// load the frames in 8 directions, 4 frames each
		// each set of frames has a walk and a fire, frame sets
		// are loaded in counter clockwise order looking down
		// from a birds eys view or the x-z plane
		for (int direction = 0; direction < 4; direction++)
		{ 
			// build up file name
			sprintf_s(filename,"greenpirate%d.BMP",direction);

			// load in new bitmap file
			Load_Bitmap_File(&bitmap8bit,filename);

			Load_Frame_BOB(&pirate[i],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&pirate[i],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&pirate[i],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&pirate[i],&bitmap8bit,3+direction*4,3,0,BITMAP_EXTRACT_MODE_CELL);  

			// unload the bitmap file
			Unload_Bitmap_File(&bitmap8bit);

			// set the animation sequences for skelaton
			Load_Animation_BOB(&pirate[i],direction,4,pirate_anims[direction]);

		} // end for direction

		// set up stating state of skelaton
		Set_Anim_Speed_BOB(&pirate[i], 4);
		Set_Vel_BOB(&pirate[i], 0,0);

		Set_Pos_BOB(&pirate[i], enemy_info[i].x, enemy_info[i].y);
		if (enemy_info[i].direction==RIGHT)
			Set_Animation_BOB(&pirate[i], 0);
		else
			Set_Animation_BOB(&pirate[i], 1);
	}
	// set clipping rectangle to screen extents so mouse cursor
	// doens't mess up at edges
	RECT screen_rect = {0,0,screen_width,screen_height};
	lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

	// hide the mouse
	ShowCursor(FALSE);

	// return success
	return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
	// this function is where you shutdown your game and
	// release all resources that you allocated

	// kill the reactor
	//Destroy_Bitmap(&reactor);
	for (int index=0; index<3; index++)
		Destroy_Bitmap(&landscape[index]);

	// kill skelaton
	Destroy_BOB(&skelaton);
	Destroy_BOB(&dagger);
	for (int i=0;i<NUMB_PIRATES;i++)
		Destroy_BOB(&pirate[i]);


	// release keyboard
	lpdikey->Unacquire();
	lpdikey->Release();
	lpdi->Release();

	// shutdonw directdraw
	DDraw_Shutdown();

	// return success
	return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{

	// this is the workhorse of your game it will be called
	// continuously in real-time this is like main() in C
	// all the calls for you game go here!


	int          index;             // looping var
	int          dx,dy;             // general deltas used in collision detection

	static int   player_moving = 0; // tracks player motion
	static PALETTEENTRY glow = {0,0,0,PC_NOCOLLAPSE};  // used to animation red border
	static int glow_count = 0, glow_dx = 5;

	// check of user is trying to exit
	if (KEY_DOWN(VK_ESCAPE) )
		PostMessage(main_window_handle, WM_DESTROY,0,0);

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	// lock the back buffer
	DDraw_Lock_Back_Surface();

	// draw the background reactor image
	//	if (back_buffer != NULL)
	//		Draw_Bitmap(&reactor, back_buffer, back_lpitch, 0);

	Draw_Bitmap(&landscape[curr_page], back_buffer, back_lpitch, 0);

	// unlock the back buffer
	DDraw_Unlock_Back_Surface();

	// get player input

	// get the keyboard data
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);

	// reset motion flag
	player_moving = 0;

	// test direction of motion, this is a good example of testing the keyboard
	// although the code could be optimized this is more educational
	if (keyboard_state[DIK_RIGHT]) 
	{
		// move skelaton
		skelaton.x+=2;
		dx=2; dy=0;

		// set motion flag
		player_moving = 1;
		fire_anim=0;
		player_info.direction=RIGHT;

		// check animation needs to change
		if (skelaton.curr_animation != SKELATON_EAST)
			Set_Animation_BOB(&skelaton,SKELATON_EAST);

	} // end if
	else if (keyboard_state[DIK_LEFT])  
	{
		// move skelaton
		skelaton.x-=2;
		dx=-2; dy=0; 

		// set motion flag
		player_moving = 1;
		fire_anim=0;

		player_info.direction=LEFT;

		// check animation needs to change
		if (skelaton.curr_animation != SKELATON_WEST)
			Set_Animation_BOB(&skelaton,SKELATON_WEST);

	} // end if
	else if (keyboard_state[DIK_SPACE]&& dag_count==0 ||fire_anim)  
	{
		dx=0; dy=0;
		fire_anim=0;
		if(skelaton.curr_frame == 11 ||skelaton.curr_frame == 15)
		{
			fire_anim=1;
			player_info.thrown=1;
			if(!dag_count)
			{

				dagger.x=skelaton.x+skelaton.width-7;
				if (player_info.direction==LEFT)
					dagger.x-=skelaton.width;
				dagger.y=skelaton.y+skelaton.height/2-10;
				dag_count=1;
				dag_dir=player_info.direction;

			}
		}
		// set motion flag
		player_moving = 1;

		// check animation needs to change
		if(player_info.direction==RIGHT)
		{
			if (skelaton.curr_animation != SKELATON_FIRE_R)
				Set_Animation_BOB(&skelaton,SKELATON_FIRE_R);
		}
		else
		{
			if (skelaton.curr_animation != SKELATON_FIRE_L)
				Set_Animation_BOB(&skelaton,SKELATON_FIRE_L);
		}

	} // end if
	else
		Set_Animation_BOB(&skelaton,0);


	DDraw_Lock_Back_Surface();

	skelaton.y+=1;
	while(Color_Scan(skelaton.x+16, skelaton.y+24,
		skelaton.x+skelaton.width-32, skelaton.y+skelaton.height-12,                                    
		245, 245, back_buffer,back_lpitch))
	{
		// push the skelaton upward, to keep it on the floor
		skelaton.y-=1;

	} // end while
	for (int i=0;i<NUMB_PIRATES;i++)
	{
		if (enemy_info[i].alive && enemy_info[i].screen==curr_page)
		{
			pirate[i].y+=1;
			while(Color_Scan(pirate[i].x+16, pirate[i].y+24,
				pirate[i].x+pirate[i].width-32, pirate[i].y+pirate[i].height-12,                                    
				245, 245, back_buffer,back_lpitch))
			{
				// push the skelaton upward, to keep it on the floor
				pirate[i].y-=1;
			} // end while
		}
	}
	DDraw_Unlock_Back_Surface();

	// only animate if player is moving
	if (player_moving||dag_count)
	{
		// animate skelaton
		if(player_moving)
		{
			Animate_BOB(&skelaton);
		}


		// see if skelaton hit a wall

		// lock surface, so we can scan it
		DDraw_Lock_Back_Surface();

		// call the color scanner with WALL_ANIMATION_COLOR, the color of the glowing wall
		// try to center the scan in the center of the object to make it 
		// more realistic
		if(player_moving)
		{
			/*if (Color_Scan((int)skelaton.x+16, (int)skelaton.y+16,
			(int)skelaton.x+skelaton.width-16, (int)skelaton.y+skelaton.height-16,                                    
			WALL_ANIMATION_COLOR, WALL_ANIMATION_COLOR, back_buffer,back_lpitch))
			{
			// back the skelaton up along its last trajectory
			skelaton.x-=dx;
			//			skelaton.y-=dy;
			} // end if */
		}
		if(dag_count)
		{
			if (Color_Scan((int)dagger.x, (int)dagger.y,
				(int)dagger.x+dagger.width, (int)dagger.y+dagger.height,                                    
				WALL_ANIMATION_COLOR, WALL_ANIMATION_COLOR, back_buffer,back_lpitch))
			{
				// back the skelaton up along its last trajectory
				dag_count=0;
			} // end if
		}

		// done, so unlock
		DDraw_Unlock_Back_Surface();

		if (dagger.x < 0 || dagger.x > (screen_width - dagger.width))
		{
			dag_count=0;
		}
		else
		{
			if (dag_dir==RIGHT)
				dagger.x+=20;
			else
				dagger.x-=20;
		}

	} // end if

	// draw the skelaton
	Draw_BOB(&skelaton, lpddsback);
	int col=0;
	for (int i=0;i<NUMB_PIRATES;i++)
	{
		if (enemy_info[i].alive && enemy_info[i].screen == curr_page)
		{
			if(Collision_BOBS(&pirate[i],&dagger) && dag_count 
				&&player_info.thrown && enemy_info[i].health>0)
			{
				col=1;
				enemy_info[i].health-=20;
				dag_count=0;
				player_info.thrown=0;
				enemy_info[i].aware=1;

			}
		}
	}
	if(!col)
	{
		Set_Animation_BOB(&dagger,1);
		Draw_BOB(&dagger, lpddsback);

	}

	for (int i=0;i<NUMB_PIRATES;i++)
	{
		if (enemy_info[i].alive && enemy_info[i].screen == curr_page)
		{

			if(enemy_info[i].health>0)
			{
				pir_dir=1;

				if((rand()%700)==0)
				{
					enemy_info[i].aware=1;
				}


				if (pirate[i].x > SCREEN_WIDTH/2 - (pirate[i].width >> 1))
				{
					enemy_info[i].direction=LEFT;
					if (pirate[i].curr_animation!=1)
						Set_Animation_BOB(&pirate[i],1);
				}
				else if (pirate[i].x < 0 + (pirate[i].width>>1))
				{
					enemy_info[i].direction=RIGHT;
					if (pirate[i].curr_animation!=0)
						Set_Animation_BOB(&pirate[i],0);
				}

				if (enemy_info[i].aware)
				{
					int collision = Collision_BOBS(&pirate[i],&skelaton);
					if(skelaton.x>pirate[i].x)
					{
						enemy_info[i].direction=RIGHT;
						if(collision)
						{
							if(pirate[i].curr_frame==10)
								player_info.health-=.5;
							pir_dir=0;
							if(pirate[i].curr_animation != 2)
								Set_Animation_BOB(&pirate[i],2);
						}
						else
						{
							if(pirate[i].curr_animation != 0)
								Set_Animation_BOB(&pirate[i],0);
						}
					}
					else
					{
						enemy_info[i].direction=LEFT;
						if(collision)
						{
							if(pirate[i].curr_frame==14)
								player_info.health-=.5;
							pir_dir=0;
							if(pirate[i].curr_animation != 3)
								Set_Animation_BOB(&pirate[i],3);
						}
						else
						{

							if(pirate[i].curr_animation != 1)
								Set_Animation_BOB(&pirate[i],1);
						}
					}

				}
				pirate[i].x+=pir_dir*enemy_info[i].direction*1;
				Animate_BOB(&pirate[i]);
				Draw_BOB(&pirate[i],lpddsback);



			}
			else
			{
				Set_Pos_BOB(&pirate[i],0,-20);
			}
		}
	}
	// animate color
	//	glow.peGreen+=glow_dx;
	glow.peRed=255;

	// test boundary
	//	if (glow.peGreen == 0 || glow.peGreen == 255)
	//		glow_dx = -glow_dx;

	Set_Palette_Entry(WALL_ANIMATION_COLOR, &glow);

	// draw some text
	//if(dag_count)
	//Draw_Rectangle(dagger.x,dagger.y,dagger.x+dagger.width, dagger.y+dagger.height,WALL_ANIMATION_COLOR,lpddsback);
	
	//sprintf_s(buffer,"Count:%d pirate frame:%d pirate_anim%d",count,pirate[i].curr_frame,pirate[NUMB_PIRATES].curr_animation);
	//count++;
	//Draw_Text_GDI(buffer,10,10,50,lpddsback);
	for (int i=0;i<NUMB_PIRATES;i++)
	{
		if (enemy_info[i].alive && enemy_info[i].screen == curr_page)
		{
			sprintf_s(buffer,"Health:%d     Enemy health:%d",player_info.health, enemy_info[i].health);
			Draw_Text_GDI(buffer,10,20 +i*15,29,lpddsback);
		}
	}
	Draw_Text_GDI("I STILL HAVE A BONE TO PICK!",0,screen_height - 32,WALL_ANIMATION_COLOR,lpddsback);

	Draw_Text_GDI("USE ARROW KEYS TO MOVE, <ESC> TO EXIT.",0,0,RGB(32,32,32),lpddsback);


	if (skelaton.x > SCREEN_WIDTH/2 - (skelaton.width >> 1))
	{
		// bump back regardless
		//skelaton.x-=dx;

		// test for page flip
		if (curr_page < 3)
		{ 
			// scroll to next page to right
			curr_page++;

			// reset character to left edge of screen
			skelaton.x = -(skelaton.width >> 1);

		} // end if

	} // end if   
	else if (skelaton.x < -(skelaton.width >> 1))
	{
		// bump back regardless
		skelaton.x=-(skelaton.width >> 1);

		// test for page flip
		if (curr_page > 0)
		{ 
			// scroll to next page to left
			curr_page--;

			// reset character to right edge of screen
			skelaton.x = SCREEN_WIDTH/2 - (skelaton.width >> 1);

		} // end if

	} // end if   



	// flip the surfaces
	DDraw_Flip();

	// sync to 30 fps
	Wait_Clock(30 );

	// return success
	return(1);

} // end Game_Main

//////////////////////////////////////////////////////////